;  2009, Andrey Lazebny, Moscow (Russian Federation)
;  2009, Translation by Nikolay Poleshchuk, Saint Petersburg (Russian Federation)
; 
; Moving custom properties up or down in the properties palette
;
; Note:
; Some dynamic blocks have many custom properties and user cannot see them all
; You can move the most useful properties up and make their visibility more convenient
;
(defun move-properties ( / )
(vl-load-com)
(if (= (getvar "BLOCKEDITOR") 1) (progn (alert "Do not use the program in block editor space!") (exit)))

;Project for moving dynamic block property names up and down in the properties list
;Block selection
(initget 1)
(setq obj-block (vlax-ename->vla-object (setq ss_ent_block (car (entsel)))))
;Getting its list of properties as vla-objects
(setq vla_spisok (vlax-safearray->list (vlax-variant-value (vla-getdynamicblockproperties obj-block))))
;Leaving in the list only properties shown in PROPERTIES palette
(setq res_spisok (vl-remove-if 'null (mapcar '(lambda (x) (if (= (vla-get-Show x) :vlax-true) (vla-get-PropertyName x))) vla_spisok)))
;Checking properties for equal names
(setq res2_spisok nil)
;(mapcar '(lambda (x) (if (member x res2_spisok) (progn (alert (strcat x "\nBlock should not contain equal property names! \nAdd a space at the end of property name!")) (exit)) (setq res2_spisok (append res2_spisok (list x))))
;) res_spisok)


;========================================================================
;Creation of DCL file

(setq Fdcl "0066Selection.dcl")                                          
(setq Fdcl (strcat (vl-filename-directory (vl-filename-mktemp Fdcl)) "\\" Fdcl))   
(vl-file-delete Fdcl) ;Kill such a file if it exists for it is created from the very beginning every time
(setq dsl0066 (open Fdcl "w")) ;Filling in 0066selection.dcl file with necessary controls
(write-line "np_prop: dialog{label=\" - Virtual Building Technologies - \";" dsl0066)
(write-line "  :row{label=\"Moving dynamic block property position\";" dsl0066)
(write-line "  :button{label=\"Move Up\";key=\"df4\";fixed_width=true;}" dsl0066)
(write-line "  :button{label=\"Move Down\";key=\"df5\";fixed_width=true;}" dsl0066)
(write-line "  }" dsl0066)
(write-line "  :list_box{label=\"Block properties list\";list=\" \";value=\" \";key=\"b10\";width=35;" dsl0066)
(write-line "  }" dsl0066)
(write-line "  :ok_button{label=\"Ok\";key=\"df3\";alignment=centered;fixed_width=true;is_cancel=true;}" dsl0066)
(write-line "  }" dsl0066)
(write-line "  //" dsl0066)
(close dsl0066)

(if (/= (setq Selprop (load_dialog Fdcl)) -1)
(new_dialog "np_prop" Selprop "" (list 222 114)) (alert "File 0066Selection.dcl not found"))
(action_tile "b10" "(modes3)") ; After action property name is stored in listprop variable
(action_tile "df3" "(done_dialog)")
(action_tile "df4" "(move_up_block)")
(action_tile "df5" "(move_down_block)")
(mode_tile "df4" 1)
(mode_tile "df5" 1)
(start_list "b4")
(setq ddffdd (mapcar 'add_list res_spisok))
(end_list)
(start_list "b10")
(setq ddffdd (mapcar 'add_list res_spisok))
(end_list)
(start_dialog)

;==========================================================================
;Creation of properties-parameters list
;(setq param_block nil)
;(mapcar '(lambda (x) (if (= (car x) 360) (setq param_block (append (list (cdr (assoc 0 (entget (cdr x))))) param_block)))) n15_block)
)

;========================================================================
; *** 1 ***

(defun restart_prop_block ()
;Getting its list of properties as vla-objects
(setq vla_spisok (vlax-safearray->list (vlax-variant-value (vla-getdynamicblockproperties obj-block))))
;Leaving in the list only properties visible in PROPERTIES palette
(setq res_spisok (vl-remove-if 'null (mapcar '(lambda (x) (if (= (vla-get-Show x) :vlax-true) (vla-get-PropertyName x))) vla_spisok)))
;Finding block effective name and getting its full descrition by name
(setq lst_name_block (entget (TBLOBJNAME "block" (vla-get-EffectiveName obj-block )) '("*")))
(setq slov_block (cdr (assoc 330 lst_name_block)))  ;Selecting dictionary with the block properties
(setq dxf_slov_block (entget slov_block))  ;Getting DXF codes list for the dictionary
(setq wq-w_block (entget (cdr (assoc 360 dxf_slov_block)))) ;Selecting dictionary (from the list) and its DXF codes
;Getting dictionary contents with block properties and DXF support
(setq n15_block (entget (setq lst_dict (car (mapcar 'cdr (vl-remove-if-not '(lambda(x) (= (car x) 360)) wq-w_block))))))

;Finding property name number in the list
(setq pos2_prop_block (vl-position listprop res_spisok))
;If number is not 0 then we find previous property name
(setq pred_prop nil)
(setq pos3_prop_block nil)
(if (> pos2_prop_block 0) (progn 
(setq pred_prop (nth (1- pos2_prop_block) res_spisok))

;and property position number in the dictionary too
(setq pos3_prop_block (vl-position (car (vl-member-if '(lambda (x) (if (= (car x) 360) 
(if (or 
(= (cdr (assoc 301 (entget (cdr x)))) pred_prop)
(= (cdr (assoc 302 (entget (cdr x)))) pred_prop)
(= (cdr (assoc 303 (entget (cdr x)))) pred_prop)
(= (cdr (assoc 304 (entget (cdr x)))) pred_prop) 
(= (cdr (assoc 305 (entget (cdr x)))) pred_prop)
(= (cdr (assoc 306 (entget (cdr x)))) pred_prop)
(= (cdr (assoc 307 (entget (cdr x)))) pred_prop)
(= (cdr (assoc 308 (entget (cdr x)))) pred_prop)
(= (cdr (assoc 309 (entget (cdr x)))) pred_prop)
(= (cdr (assoc 303 (entget (cdr x)))) (substr pred_prop 1 (- (strlen pred_prop) 2)))
) 
(setq n17_block (cdr x))))) n15_block)) n15_block))
;and also look and remember element ordinal number in display order
(setq num3_prop_block (nth (- pos3_prop_block 3) n15_block))
))

;Finding last property number in the list
(setq num_posl_block (1- (length res_spisok)))

;If property number is less than the last property number then we find next property name
(setq posl_prop nil)
(setq pos4_prop_block nil)
(if (< pos2_prop_block num_posl_block) (progn 
(setq posl_prop (nth (1+ pos2_prop_block) res_spisok))

;and property position number in the dictionary too
(setq pos4_prop_block (vl-position (car (vl-member-if '(lambda (x) (if (= (car x) 360) 
(if (or 
(= (cdr (assoc 301 (entget (cdr x)))) posl_prop)
(= (cdr (assoc 302 (entget (cdr x)))) posl_prop)
(= (cdr (assoc 303 (entget (cdr x)))) posl_prop)
(= (cdr (assoc 304 (entget (cdr x)))) posl_prop) 
(= (cdr (assoc 305 (entget (cdr x)))) posl_prop)
(= (cdr (assoc 306 (entget (cdr x)))) posl_prop)
(= (cdr (assoc 307 (entget (cdr x)))) posl_prop)
(= (cdr (assoc 308 (entget (cdr x)))) posl_prop)
(= (cdr (assoc 309 (entget (cdr x)))) posl_prop)
(= (cdr (assoc 303 (entget (cdr x)))) (substr posl_prop 1 (- (strlen posl_prop) 2)))
) 
(setq n17_block (cdr x))))) n15_block)) n15_block))
;and also look and remember element ordinal number in display order
(setq num4_prop_block (nth (- pos4_prop_block 3) n15_block))
))

;Finding in the dictionary element position with selected property
(setq pos_prop_block (vl-position (car (vl-member-if '(lambda (x) (if (= (car x) 360) 
(if (or 
(= (cdr (assoc 301 (entget (cdr x)))) listprop)
(= (cdr (assoc 302 (entget (cdr x)))) listprop)
(= (cdr (assoc 303 (entget (cdr x)))) listprop)
(= (cdr (assoc 304 (entget (cdr x)))) listprop)
(= (cdr (assoc 305 (entget (cdr x)))) listprop)
(= (cdr (assoc 306 (entget (cdr x)))) listprop)
(= (cdr (assoc 307 (entget (cdr x)))) listprop)
(= (cdr (assoc 308 (entget (cdr x)))) listprop)
(= (cdr (assoc 309 (entget (cdr x)))) listprop)
(= (cdr (assoc 303 (entget (cdr x)))) (substr listprop 1 (- (strlen listprop) 2)))
) 
(setq n16_block (cdr x))))) n15_block)) n15_block))

;Look and remember element ordinal number in display order
(setq num_prop_block (nth (- pos_prop_block 3) n15_block))

(mode_tile "df5" 1)
(mode_tile "df4" 1)
(if (and (= (cdr num_prop_block) (cdr num4_prop_block)) (<= (+ pos2_prop_block 2) num_posl_block)) (mode_tile "df5" 0))
(if (and (< pos2_prop_block num_posl_block) (not (null num4_prop_block)) (/= (cdr num_prop_block) (cdr num4_prop_block))) (mode_tile "df5" 0))
(if (and (= (cdr num_prop_block) (cdr num3_prop_block)) (>= (- pos2_prop_block 2) 0)) (mode_tile "df4" 0))
(if (and (> pos2_prop_block 0) (not (null num3_prop_block)) (/= (cdr num_prop_block) (cdr num3_prop_block))) (mode_tile "df4" 0))
)

;========================================================================
; *** 2 ***

(defun move_up_block ()
(restart_prop_block)
;Look and remember previous element ordinal number in display order
(setq pred_prop (nth (1- pos2_prop_block) res_spisok))
;Find its number in the dictionary
(setq pos3_prop_block (vl-position (car (vl-member-if '(lambda (x) (if (= (car x) 360) 
(if (or 
(= (cdr (assoc 301 (entget (cdr x)))) pred_prop)
(= (cdr (assoc 302 (entget (cdr x)))) pred_prop)
(= (cdr (assoc 303 (entget (cdr x)))) pred_prop)
(= (cdr (assoc 304 (entget (cdr x)))) pred_prop) 
(= (cdr (assoc 305 (entget (cdr x)))) pred_prop)
(= (cdr (assoc 306 (entget (cdr x)))) pred_prop)
(= (cdr (assoc 307 (entget (cdr x)))) pred_prop)
(= (cdr (assoc 308 (entget (cdr x)))) pred_prop)
(= (cdr (assoc 309 (entget (cdr x)))) pred_prop)
(= (cdr (assoc 303 (entget (cdr x)))) (substr pred_prop 1 (- (strlen pred_prop) 2)))
) 
(setq n17_block (cdr x))))) n15_block)) n15_block))
;Look and remember element ordinal number in display order
(setq num3_prop_block (nth (- pos3_prop_block 3) n15_block))
(if (= (cdr num3_prop_block) (cdr num_prop_block))
(progn
(setq pred_prop (nth (- pos2_prop_block 2) res_spisok))
(setq pos3_prop_block (vl-position (car (vl-member-if '(lambda (x) (if (= (car x) 360) 
(if (or 
(= (cdr (assoc 301 (entget (cdr x)))) pred_prop)
(= (cdr (assoc 302 (entget (cdr x)))) pred_prop)
(= (cdr (assoc 303 (entget (cdr x)))) pred_prop)
(= (cdr (assoc 304 (entget (cdr x)))) pred_prop) 
(= (cdr (assoc 305 (entget (cdr x)))) pred_prop)
(= (cdr (assoc 306 (entget (cdr x)))) pred_prop)
(= (cdr (assoc 307 (entget (cdr x)))) pred_prop)
(= (cdr (assoc 308 (entget (cdr x)))) pred_prop)
(= (cdr (assoc 309 (entget (cdr x)))) pred_prop)
(= (cdr (assoc 303 (entget (cdr x)))) (substr pred_prop 1 (- (strlen pred_prop) 2)))
) 
(setq n17_block (cdr x))))) n15_block)) n15_block))
(setq num3_prop_block (nth (- pos3_prop_block 3) n15_block))
))

(setq n15_block (subst '(1) num3_prop_block n15_block))
(setq n15_block (subst '(2) num_prop_block n15_block))
(setq n15_block (subst num3_prop_block '(2) n15_block))
(setq n15_block (subst num_prop_block '(1) n15_block))
(entmod n15_block)
(setq prop_1-1 (entget (cdr (nth pos_prop_block n15_block))))
(setq prop_1-2 (vl-remove (assoc 1071 prop_1-1) prop_1-1))
(setq prop_1-3 (vl-remove (assoc 1010 prop_1-1) prop_1-2))
(setq prop_1-3 (vl-remove (assoc 1011 prop_1-1) prop_1-3))
(setq prop_1-3 (vl-remove (assoc 1012 prop_1-1) prop_1-3))
(entmod prop_1-3)
(setq obj-block-ename (entget ss_ent_block))
(entmod obj-block-ename)
(restart_prop_block)
(start_list "b4")
(setq ddffdd (mapcar 'add_list res_spisok))
(end_list)
(start_list "b10")
(setq ddffdd (mapcar 'add_list res_spisok))
(end_list)
(setq num_listprop (vl-position listprop res_spisok))
(set_tile "b4" (itoa num_listprop))
(set_tile "b10" (itoa num_listprop))
(restart_prop_block)
)

;========================================================================
; *** 3 ***

(defun move_down_block ()
(restart_prop_block)
;Look and remember next element ordinal number in display order
(setq pred_prop (nth (1+ pos2_prop_block) res_spisok))
;Find its number in the dictionary
(setq pos3_prop_block (vl-position (car (vl-member-if '(lambda (x) (if (= (car x) 360) 
(if (or 
(= (cdr (assoc 301 (entget (cdr x)))) pred_prop)
(= (cdr (assoc 302 (entget (cdr x)))) pred_prop)
(= (cdr (assoc 303 (entget (cdr x)))) pred_prop)
(= (cdr (assoc 304 (entget (cdr x)))) pred_prop) 
(= (cdr (assoc 305 (entget (cdr x)))) pred_prop)
(= (cdr (assoc 306 (entget (cdr x)))) pred_prop)
(= (cdr (assoc 307 (entget (cdr x)))) pred_prop)
(= (cdr (assoc 308 (entget (cdr x)))) pred_prop)
(= (cdr (assoc 309 (entget (cdr x)))) pred_prop)
(= (cdr (assoc 303 (entget (cdr x)))) (substr pred_prop 1 (- (strlen pred_prop) 2)))
) 
(setq n17_block (cdr x))))) n15_block)) n15_block))
;Look and remember element ordinal number in display order
(setq num3_prop_block (nth (- pos3_prop_block 3) n15_block))
(if (= (cdr num3_prop_block) (cdr num_prop_block))
(progn
(setq pred_prop (nth (+ pos2_prop_block 2) res_spisok))
(setq pos3_prop_block (vl-position (car (vl-member-if '(lambda (x) (if (= (car x) 360) 
(if (or 
(= (cdr (assoc 301 (entget (cdr x)))) pred_prop)
(= (cdr (assoc 302 (entget (cdr x)))) pred_prop)
(= (cdr (assoc 303 (entget (cdr x)))) pred_prop)
(= (cdr (assoc 304 (entget (cdr x)))) pred_prop) 
(= (cdr (assoc 305 (entget (cdr x)))) pred_prop)
(= (cdr (assoc 306 (entget (cdr x)))) pred_prop)
(= (cdr (assoc 307 (entget (cdr x)))) pred_prop)
(= (cdr (assoc 308 (entget (cdr x)))) pred_prop)
(= (cdr (assoc 309 (entget (cdr x)))) pred_prop)
(= (cdr (assoc 303 (entget (cdr x)))) (substr pred_prop 1 (- (strlen pred_prop) 2)))
) 
(setq n17_block (cdr x))))) n15_block)) n15_block))
(setq num3_prop_block (nth (- pos3_prop_block 3) n15_block))
))

(setq n15_block (subst '(1) num3_prop_block n15_block))
(setq n15_block (subst '(2) num_prop_block n15_block))
(setq n15_block (subst num3_prop_block '(2) n15_block))
(setq n15_block (subst num_prop_block '(1) n15_block))
(entmod n15_block)
(setq prop_1-1 (entget (cdr (nth pos_prop_block n15_block))))
(setq prop_1-2 (vl-remove (assoc 1071 prop_1-1) prop_1-1))
(setq prop_1-3 (vl-remove (assoc 1010 prop_1-1) prop_1-2))
(setq prop_1-3 (vl-remove (assoc 1011 prop_1-1) prop_1-3))
(setq prop_1-3 (vl-remove (assoc 1012 prop_1-1) prop_1-3))
(entmod prop_1-3)
(setq obj-block-ename (entget ss_ent_block))
(entmod obj-block-ename)
(restart_prop_block)
(start_list "b4")
(setq ddffdd (mapcar 'add_list res_spisok))
(end_list)
(start_list "b10")
(setq ddffdd (mapcar 'add_list res_spisok))
(end_list)
(setq num_listprop (vl-position listprop res_spisok))
(set_tile "b4" (itoa num_listprop))
(set_tile "b10" (itoa num_listprop))
(restart_prop_block)
)

;========================================================================
; *** 4 ***

;Creation of function for selected value calculation
(defun modes3 ( / ) 
(setq listprop (nth (atoi (get_tile "b10")) res_spisok))
(restart_prop_block)
)
